      SUBROUTINE ELLIPS(X,INIT,KODE,T,Y,DXY,RX,RY,EM)
CP  GIVES STATE VECTOR AND PARTIAL DERIVATIVES OF AN ELLIPTICAL ORBIT
CP  CALLS THE SUBROUTINE PARDER FOR THE PARTIAL DERIVATIVES
C
CI  X(6) = POSITION (X(1)..X(3)) AND VELOCITY (X(4)..X(6)), (KM,KM/SEC)
CI  INIT = 0 FOR EACH NEW X. OLD VALUE SHOULD HAVE INIT.GT.0
CI  KODE = 1  ONLY POSITION IN Y(1)..Y(3) AND NOT DXY
CI       = 2  POSITION + VELOCITY IN Y(1)..Y(6) BUT NOT DXY
CI       = 3  AS 2 + HALF OF DXY(I,K), I=1,..3,  K=1,..6
CI       = 4  WHOLE Y AND DXY
CI  T = TIME DIFFERENCE (SEC) BETWEEN X AND Y
C
CO  Y(6)     = STATE VECTOR AFTER TIME T
CO  DXY(6,6) = PARTIAL DERIVATIVES DXY(I,K) = DY(I)/DX(K)
CO  RX       = SQRT(X(1)**2+X(2)**2+X(3)**2)
CO  RY       = SQRT(Y(1)**2+Y(2)**2+Y(3)**2)       ONLY IF KODE.GE.2
CO  EM       = MEAN MOTION
C
C  ONLY ELLIPTIC ORBITS ARE POSSIBLE. ERROR DIAGNOSTICS IS A ZERO OR
C  NEGATIVE VALUE OF EM.
C
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/CPOEMS/ XMU,WMU,WMUIN,XMUM,XMUS
      DIMENSION X(6),Y(6),G(3),DXY(6,6)
      DATA KNIT/0/
      IF(INIT*KNIT .LE. 0) GOTO 10
      TAM = T*AM-RVWAM
      COMP = 1.D-7 + 1.D-10*DABS(TAM)
      IF(AME) 45,45,40
 10   KNIT = 1
      RX = DSQRT(X(1)**2+X(2)**2+X(3)**2)
      A = 2.D0/RX -(X(4)**2+X(5)**2+X(6)**2)/XMU
      WA = DSQRT(DABS(A))
      AME = WMU*WA*A
      AM = DMAX1(AME,1.D-30)
      WA = DMAX1(WA,1.D-30)
      A = DMAX1(A,1.D-30)
      AR = A*RX
      ARM = AR - 1.D0
      WMAR = WMU/(WA*RX)
      RVWAM= (X(1)*X(4)+X(2)*X(5)+X(3)*X(6))*WMUIN*WA
C  CALC. OF ECC. ANOMALY BY NEWTON'S ITERATION
      TAM = T*AM-RVWAM
      COMP = 1.D-7 + 1.D-10*DABS(TAM)
      BET = TAM
 20   B = BET
 30   GO = DCOS(B)
      G(1) = DSIN(B)
C  ONLY ELLIPSES ALLOWED
      IF(AME) 45,45,40
 40   BET = TAM-ARM*G(1)+RVWAM*GO
      D = (BET-B)/(1.D0+ARM*GO+RVWAM*G(1))
      ABSD = DABS(D)
      IF(ABSD .GT. 3.D0) GOTO 20
      B = B+D
      IF(ABSD.GT.COMP) GOTO 30
C  THIS GIVES THE ACCURACY  1.D-14 IN B AND THE G'S
      GO = GO-D*G(1)
      G(1) = G(1)+D*GO
45    CONTINUE
      G(2) = 1.D0-GO
      G(3) = B-G(1)
      FX = 1.D0-G(2)/AR
      GX = T-G(3)/AM
      DO 50 J = 1,3
 50   Y(J) = FX*X(J)+GX*X(J+3)
      EM=AME
      IF(KODE .LE. 1) RETURN
      RY = DSQRT(Y(1)**2+Y(2)**2+Y(3)**2)
      FT = -WMAR*G(1)/RY
      GT = 1.D0-G(2)/(RY*A)
      DO 60 J=4,6
 60   Y(J) = FT*X(J-3)+GT*X(J)
      IF(KODE .LE. 2) RETURN
C  CALC. OF PARTIAL DERIVATIVES
      CALL PARDER(X,Y,KODE,DXY,AR,A,AM,RY,RVWAM,B,GO,G,FX,GX,FT,GT)
      RETURN
      END
